<?php
// $Id: weblinks_config2_basic_handler.php,v 1.4 2007/02/04 10:48:53 ohwada Exp $

// 2007-02-04 K.OHWADA
// Notice: Only variables should be assigned by reference in file class/weblinks_link.php

// 2006-12-10 K.OHWADA
// add _load()

// 2006-09-20 K.OHWADA
// use happy_linux

// 2006-05-15 K.OHWADA
// this is new file
// use new handler

//=========================================================
// WebLinks Module
// 2006-05-15 K.OHWADA
//=========================================================

//---------------------------------------------------------
// TODO
// global $xoopsUser, $xoopsModule;
//---------------------------------------------------------


// === class begin ===
if( !class_exists('weblinks_config2_basic_handler') ) 
{

//=========================================================
// class weblinks_config2_basic_handler
// this class handle MySQL table directly
// this class does not use another class
//=========================================================
class weblinks_config2_basic_handler extends happy_linux_basic_handler
{

//---------------------------------------------------------
// constructor
//---------------------------------------------------------
function weblinks_config2_basic_handler( $dirname )
{
	$this->happy_linux_basic_handler( $dirname );

	$this->set_table_name('config2');
	$this->set_id_name('conf_id');

	$this->set_debug_db_sql(   WEBLINKS_DEBUG_CONFIG2_BASIC_SQL );
	$this->set_debug_db_error( WEBLINKS_DEBUG_ERROR );
}

//---------------------------------------------------------
// initiatl load
//---------------------------------------------------------
function init()
{
	static $flag_init_load;

	if ( !isset($flag_init_load) )
	{
		$flag_init_load = 1;
		$this->_load();
	}
}

// for debug
function _load()
{
	$arr =& $this->_get_config_data();

// if not initial
	if ( !is_array($arr) || ( count($arr) == 0 ) )
	{	return false;	}

	$arr['auth_submit_arr']      = unserialize( $arr['auth_submit'] );
	$arr['auth_submit_auto_arr'] = unserialize( $arr['auth_submit_auto'] );
	$arr['auth_modify_arr']      = unserialize( $arr['auth_modify'] );
	$arr['auth_modify_auto_arr'] = unserialize( $arr['auth_modify_auto'] );
	$arr['auth_ratelink_arr']    = unserialize( $arr['auth_ratelink'] );
	$arr['dohtml_arr']    = unserialize( $arr['auth_dohtml'] );
	$arr['dosmiley_arr']  = unserialize( $arr['auth_dosmiley'] );
	$arr['doxcode_arr']   = unserialize( $arr['auth_doxcode'] );
	$arr['doimage_arr']   = unserialize( $arr['auth_doimage'] );
	$arr['dobr_arr']      = unserialize( $arr['auth_dobr'] );
	$arr['rss_site_arr']  =& $this->_conv_to_array( $arr['rss_site'] );
	$arr['rss_black_arr'] =& $this->_conv_to_array( $arr['rss_black'] );
	$arr['rss_white_arr'] =& $this->_conv_to_array( $arr['rss_white'] );

	$this->_conf_cached = $arr;
}

//=========================================================
// function for MySQL table
//=========================================================
function &_conv_to_array($str)
{
	$ret =& $this->convert_string_to_array($str, "\n");
	return $ret;
}

//---------------------------------------------------------
// has authority
//---------------------------------------------------------
function has_auth_ratelink()
{
	$ret = $this->has_auth( 'auth_ratelink_arr' );
	return $ret;
}

// Notice: Only variables should be assigned by reference in file class/weblinks_link.php
function &has_auth_desc_option()
{
	$arr = array(
		'dohtml'   => $this->has_auth( 'dohtml_arr' ),
		'dosmiley' => $this->has_auth( 'dosmiley_arr' ),
		'doxcode'  => $this->has_auth( 'doxcode_arr' ),
		'doimage'  => $this->has_auth( 'doimage_arr' ),
		'dobr'     => $this->has_auth( 'dobr_arr' ),
	);

	return $arr;
}

function has_auth( $auth_arr_name )
{
	if ( $this->is_xoops_module_admin() )
	{
		return true;
	}

	$auth_arr = $this->get_conf_by_name( $auth_arr_name );
	$groups   = $this->get_xoops_groups();

	if ( array_intersect( $auth_arr, $groups ) )
	{
		return true;
	}

	return false;
}

function show_modify( $rec_uid )
{
	list($is_permit, $is_owner, $show_passwd) =
		$this->has_auth_owner( 'auth_modify_arr', $rec_uid);

	if ( $is_permit || $show_passwd )
	{
		return true;
	}

	return false;
}

function has_auth_owner( $auth_arr_name, $rec_uid, $flag_passwd=false )
{
	$is_permit   = false;
	$is_owner    = false;
	$show_passwd = false;

	$rec_uid    = intval($rec_uid);
	$xoops_uid  = $this->get_xoops_uid();
	$use_passwd = $this->get_conf_by_name( 'use_passwd' );
	$has_auth_uid    = $this->has_auth_uid( $auth_arr_name );
	$has_auth_passwd = $this->has_auth_passwd( $auth_arr_name );

	if ( $this->has_auth( $auth_arr_name ) )
	{
		$is_permit = true;
	}

// uid
	if ( ( $xoops_uid > 0 )&&( $xoops_uid == $rec_uid )&& $has_auth_uid )
	{
		$is_permit = true;
		$is_owner  = true;
	}

// passwd
	if ( ( $xoops_uid == 0 ) && $use_passwd && $has_auth_passwd )
	{
		$show_passwd = true;

		if ( $flag_passwd )
		{
			$is_permit = true;
			$is_owner  = true;
		}
	}

	return array($is_permit, $is_owner, $show_passwd);
}

function has_auth_uid( $auth_arr_name )
{
	$auth_arr = $this->get_conf_by_name( $auth_arr_name );

	if ( in_array( WEBLINKS_ID_AUTH_UID, $auth_arr ) )
	{
		return true;
	}

	return false;
}

function has_auth_passwd( $auth_arr_name )
{
	$auth_arr = $this->get_conf_by_name( $auth_arr_name );

	if ( in_array( WEBLINKS_ID_AUTH_PASSWD, $auth_arr ) )
	{
		return true;
	}

	return false;
}

//---------------------------------------------------------
// xoops system parameter
//---------------------------------------------------------
function is_xoops_module_admin()
{
	global $xoopsUser, $xoopsModule;

	if ( is_object($xoopsUser) && is_object($xoopsModule) )
	{
		if ( $xoopsUser->isAdmin( $xoopsModule->mid() )) 
		{
			return true;
		}
	}

	return false;
}

function get_xoops_uid()
{
	global $xoopsUser;

	$uid = 0;

	if ( is_object($xoopsUser) )
	{
		$uid = $xoopsUser->getVar('uid');
	}

	return $uid;
}

function get_xoops_groups()
{
	global $xoopsUser;

	$groups = array();

	if ( is_object($xoopsUser) )
	{
		$groups = $xoopsUser->getGroups();
	}
	else
	{
		$groups = array( XOOPS_GROUP_ANONYMOUS );
	}

	return $groups;
}

// --- class end ---
}

// === class end ===
}

?>